﻿using HeuristicLab.Common;
using HeuristicLab.Core;
using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.Problems.Robocode
{
    [StorableClass]
    public sealed class Solution : NamedItem
    {
        //private int moves;
        //[Storable]
        //public int Moves
        //{
        //    get { return moves; }
        //    private set { this.moves = value; }
        //}
        //private int shots;
        //[Storable]
        //public int Shots
        //{
        //    get { return shots; }
        //    private set { this.shots = value; }
        //}
        private ISymbolicExpressionTree tree;
        [Storable]
        public ISymbolicExpressionTree Tree
        {
            get { return tree; }
            private set { this.tree = value; }
        }

        private string path;
        [Storable]
        public string Path
        {
            get { return path; }
            private set { this.path = value; }
        }

        [StorableConstructor]
        private Solution(bool deserializing) : base(deserializing) { }
        private Solution(Solution original, Cloner cloner)
            : base(original, cloner)
        {
            //this.moves = original.moves;
            //this.shots = original.shots;
            this.tree = cloner.Clone(tree);
        }

        public Solution(ISymbolicExpressionTree tree, string path)// int moves, int shots)
            : base("Solution", "A tank program.")
        {
            this.tree = tree;
            this.path = path;
            //this.moves = moves;
            //this.shots = shots;
        }
        [StorableHook(HookType.AfterDeserialization)]
        private void AfterDeserialization()
        {
        }
        public override IDeepCloneable Clone(Cloner cloner)
        {
            return new Solution(this, cloner);
        }
    }
}